#ifndef AGENTHEADER
#define AGENTHEADER

#include "Actor.h"
#include "InputEvent.h"
#include <vector>
#include <set>


class Agent
{
protected:
	Actor actor;
	std::vector<InputEvent> events;
	Agent * opponent;
	std::vector<std::string> thoughts;


public:
	Agent();
	~Agent();
	bool LoadActor(const char * filename);
	void SetPosition(const Vector3 & pos);
	void SetHeading(float h);
	void AddInputEvent(InputEvent & event);
	void UpdateAnim();
	void Render();
	void SetOpponent(Agent * op);
	virtual void Think() = 0;

	std::string GetThoughts(const unsigned int index);
	Actor * GetActor();
};

#endif