#ifndef SKELCHARINSTHEADER
#define SKELCHARINSTHEADER

class SkelCharInst;
#include "RenderableObject.h"
#include "SkelChar.h"
#include "Matrix4x4.h"
#include "Vector3.h"
#include "Quaternion.h"
#include <Pose.h>
#include <vector>
#include <string>


class SkelCharInst: public RenderableObject
{
	friend class SkelChar;
	SkelChar * skelly;


	struct defjoint
	{
		Matrix4x4 Mfinal; // final skinning transform

		//the decomposed animation transform for the joint
		Matrix4x4 xRot;
		Vector3 xScale;
		Vector3 xTrans;
		Matrix4x4 xform;
		bool dirty; //if true, the joint needs to be updated on the next deform
	};

	std::vector<Vector3> verts; //deformed vertex positions
	std::vector<Vector3> norms; //deformed normal orientations
	std::vector<defjoint> joints; //deformed joint info
	
	GLfloat * interleavedArray;
	bool useInterleaved;
	void Init();

public:
	SkelCharInst();
	SkelCharInst(SkelChar & skelly,bool inter);
	~SkelCharInst();
	void Draw();
	void SetJointTransform(const unsigned int joint, const Matrix4x4 & rot, const Vector3 & scale, const Vector3 & trans);
	void Deform();
	void GetJointAngle(const unsigned int joint, Matrix4x4 & m) const;
	int GetNumJoints() const;
	void GetPose(Pose & p) const;
	void SetPose(Pose & p);
	void GetJointXform(const unsigned int joint, Matrix4x4 & m);
	void GetJointXform(const char * name, Matrix4x4 & m);

};


#endif